<!DOCTYPE html>
<html lang="en">
<head>
	<title>Car Game</title>
	<meta charset="utf-8"/>
	<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
	<style>
		body { 
			margin: 0px; 
			padding: 0px; 
			overflow: hidden;
			color:white;
			font-family: Tahoma;
			text-align: center;
		}
		.container{
			background-color:rgba(0,0,0,0.9);
			position: relative;
			width:100vw;
			height:100vh;
		}
		.info, .info2{
			position: absolute;
		}
		.controls{
			position: absolute;
			height:auto;
			text-align:center;
			top:50%;
			left:50%;
			transform: translate(-50%,-50%);
		}
		.controls .c{
			font-size:1.3em;
			padding:30px;
		}
		ul{
			list-style: none;
		}
		ul>li>span{
			font-weight: bolder;
			color:red;
			width:90px;
			font-size: 1.6em;
			text-align: right;
		}
		button{
			background-color:black;
			color:white;
			border:3px solid white;
			width:300px;
			font-size: large;
			text-align: center;
			transition:all 0.8;
			cursor: pointer;
			font-weight: bolder;
		}
		button:hover{
			transition:all 0.8;
			background-color:white;
			color:black;
		}
		#back {
                position: absolute;
                left: 0px;
                top: 0px;
                padding: 4px;
                color: yellow;   
                font-weight: bold;
            }
		
	</style>
	<script type="text/javascript" src="libs/three.js"></script>
	<script type="text/javascript" src="libs/BinaryLoader.js"></script>
	<script type="text/javascript" src="libs/dat.gui.js"></script>
	<script type="text/javascript" src="libs/stats.js"></script>
	<script type="text/javascript" src="libs/helvetiker_bold.typeface.js"></script>
    <script type="text/javascript" src="libs/helvetiker_regular.typeface.js"></script>
	<script type="text/javascript" src="libs/TextGeometry.js"></script>
	<script src="../../constant.js"></script>
	
</head>

<body onload="init()">
	<div class="container">
		<div id="info" ></div>
		<div id="info2"></div>
		<div id="loading">
			<h1>CAR GAME</h1>
			<div class="controls">
				<br> <br>
				<div><br>
				<div class="c" style="text-align: left;">
				<ul>
					<li> <span>W </span> ACCELERATION </li>
					<li> <span>S &nbsp;</span> BACK </li>
					<li> <span>A &nbsp;</span> STEER LEFT </li>
					<li> <span>D &nbsp;</span> STEER RIGHT </li>
					<li> <span>1 &nbsp;</span> CAMERA 1 </li>
					<li> <span>2 &nbsp;</span> CAMERA 2 </li>
					<li> <span>3 &nbsp;</span> CAMERA 3 </li>
					<li> <span>4 &nbsp;</span> CAMERA 4 </li>
					<li> <span>Q &nbsp;</span> TOGGLE MUSIC on/off </li>
					<br>
				</ul> 
				</div>
			</div> 
				<button style="height: 50px;" onclick="gameOn();">PLAY</button>
			</div>
		</div>
	</div>
	<div id="canvas"></div>

<script type="text/javascript">
	var collidableMeshList = [];

	var scene, renderer, controls, car, camera1, camera2, camera3, camera4,
		whichCamera = 1, car, carLoaded = false, dir, gui, velocity = 0.000,
		seed = 6, piRatio = Math.PI/180, FORWARD = false, BACKWARD = false,
		BRAKING = false, POWER = false, maxAnisotropy, musicPlaying = false;

	function init() {
		scene = new THREE.Scene();
		camera1 = new THREE.PerspectiveCamera( 60, window.innerWidth/window.innerHeight, 1, 200000 );
		camera2 = new THREE.PerspectiveCamera( 60, window.innerWidth/window.innerHeight, 1, 200000 );
		camera3 = new THREE.PerspectiveCamera( 60, window.innerWidth/window.innerHeight, 1, 200000 );
		camera4 = new THREE.PerspectiveCamera( 45, window.innerWidth/window.innerHeight, 1, 200000 );

		dir = new THREE.Vector3(0.0, 0.0, 20.0);

		stats = new Stats();
		document.getElementById("info").appendChild(stats.domElement);

		guiParams = { speed: 0.001 };
		gui = new dat.GUI({autoPlace: false});
		gui.add(guiParams, "speed").name("Velocity").listen();  
		document.getElementById("info2").appendChild(gui.domElement);

		
		renderer = new THREE.WebGLRenderer( { antialias: true } );
		renderer.setSize( window.innerWidth, window.innerHeight );
		renderer.setPixelRatio( window.devicePixelRatio );
		renderer.setClearColor(new THREE.Color(0xffffff));
		
		
		renderer.shadowMapEnabled = true;
		renderer.shadowMapType = THREE.PCFSoftShadowMap;

		
		window.addEventListener('resize', onWindowResize, false );

		
		document.onkeydown = function (ev) { 
			keydown(ev); 
		};
		document.onkeyup = function (ev) { 
			keyup(ev); 
		};

		scene.add( new THREE.AmbientLight(0x636363) );

		var spot1Light = new THREE.SpotLight( 0xffffff, 1.0, 100000, Math.PI/2);
		spot1Light.castShadow = true;
		spot1Light.onlyShadow = true;
		spot1Light.shadowCameraVisible = false;
    	spot1Light.shadowMapWidth = 2048;
    	spot1Light.shadowMapHeight = 2048;
		spot1Light.shadowDarkness = 0.5;
		spot1Light.shadowBias = -0.0005;
		spot1Light.position.set(100, 300,-2000);
		scene.add( spot1Light );

		var spot2Light = new THREE.SpotLight( 0xffffff, 1.0, 100000, Math.PI/2);
		spot2Light.castShadow = true;
		spot2Light.onlyShadow = true;
		spot2Light.shadowCameraVisible = false;
		spot2Light.shadowMapWidth = 2048;
		spot2Light.shadowMapHeight = 2048;
		spot2Light.shadowDarkness = 0.5;
		spot2Light.shadowBias = -0.0005;
		spot2Light.position.set( -3500,500,7000);
		scene.add( spot2Light );

		var pointLight = new THREE.PointLight( 0xffffff, 0.8);
		pointLight.position.set( 0,5000,0 );
		scene.add( pointLight );


		var imagePrefix = "textures/skybox/";
		var directions  = ["xpos", "xneg", "ypos", "yneg", "zpos", "zneg"];
		var imageSuffix = ".jpg";
		var urls = [];
		
		for (var i = 0; i < 6; i++)		
			urls[i] = imagePrefix + directions[i] + imageSuffix;

		var cubemap = THREE.ImageUtils.loadTextureCube(urls);   

		var shader = THREE.ShaderLib['cube'];   
		shader.uniforms['tCube'].value = cubemap;    
		var skyBoxMaterial = new THREE.ShaderMaterial( {	
		  fragmentShader: shader.fragmentShader,
		  vertexShader: shader.vertexShader,
		  uniforms: shader.uniforms,
		  depthWrite: false,
		  side: THREE.BackSide
		});

		var skybox = new THREE.Mesh( new THREE.BoxGeometry( 20000, 20000, 20000 ), skyBoxMaterial );
		scene.add(skybox);

		var carMaterials = [					    
			new THREE.MeshLambertMaterial( { color: new THREE.Color('white'), side: THREE.DoubleSide } ),
													
			new THREE.MeshLambertMaterial( { color: new THREE.Color('black'), side: THREE.DoubleSide } ),
													
			new THREE.MeshLambertMaterial( { color: new THREE.Color('black'), side: THREE.DoubleSide  } ),
			 										
			new THREE.MeshLambertMaterial( { color: new THREE.Color('orange'), side: THREE.DoubleSide, envMap: cubemap } ),
													
			new THREE.MeshLambertMaterial( { color: new THREE.Color('red'), side: THREE.DoubleSide  } ),
													
			new THREE.MeshPhongMaterial( { color: new THREE.Color('red'), specular:0xffaaaa, side: THREE.DoubleSide  } ),
													
			new THREE.MeshPhongMaterial( { color: new THREE.Color('yellow'), specular:0xbbaa99, shininess: 50, side: THREE.DoubleSide } ),
		];
		var multiMat = new THREE.MeshFaceMaterial(carMaterials);

		
		var loader = new THREE.BinaryLoader();
		loader.load( "gallardo/GallardoNoUv_bin.js", function( geometry ) {
				car = new THREE.Mesh(geometry, multiMat);
				car.position.set(0, -89.5 ,0);
				car.scale.set(0.2,0.2,0.2);
				car.castShadow = true;
				car.receiveShadow = true;
				scene.add(car);

				
				car.add(camera1);
				camera1.position.set(0.0, 150.0, -600.0); 
				camera1.lookAt(car.position);

				car.add(camera2);
				camera2.position.set(0.0, 100.0, -400.0);
				camera2.lookAt(new THREE.Vector3(car.position.x, car.position.y, car.position.z + 500));

				car.add(camera3);
				camera3.position.set(0.0, 80.0, 50.0);
				camera3.lookAt(new THREE.Vector3(car.position.x, car.position.y - 50, car.position.z + 500));

				camera4.lookAt(car.position);
				carLoaded = true;    
		} );


		
		var geoFloor = new THREE.PlaneBufferGeometry(15000,15000);
		var texFloor = THREE.ImageUtils.loadTexture("textures/grasslight-big.jpg");
		texFloor.minFilter = texFloor.magFilter = THREE.LinearFilter;
		texFloor.wrapS = texFloor.wrapT = THREE.RepeatWrapping;
		texFloor.anisotropy = maxAnisotropy;
		texFloor.repeat.set(20,20);

		var bumpFloor = THREE.ImageUtils.loadTexture("textures/grasslight-big-nm.jpg");
		bumpFloor.minFilter = bumpFloor.magFilter = THREE.LinearFilter;
		bumpFloor.wrapS = bumpFloor.wrapT = THREE.RepeatWrapping;
		bumpFloor.anisotropy = maxAnisotropy;
		bumpFloor.repeat.set(20,20);

		var matFloor = new THREE.MeshPhongMaterial({color: 0xffffff,
			map: texFloor,
			normalMap: bumpFloor, normalScale: new THREE.Vector2(0.9,0.9),  
			polygonOffset: true, polygonOffsetFactor: 10, polygonOffsetUnits: 4.0, 
			shading: THREE.SmoothShading, side: THREE.BackSide});

		var floor = new THREE.Mesh(geoFloor, matFloor);
		floor.rotation.x += Math.PI / 2;
		floor.position.set(0,-100,0);
		floor.receiveShadow = true;
		collidableMeshList.push(floor);
		scene.add(floor);

		
		var trackObj = track();
		trackObj.scale.set(8,8,8);
		trackObj.position.set(1100,-140,0);
		scene.add(trackObj);

		
		var plants = loadPlants();
		scene.add(plants);

		
		var city = buildings();
		city.castShadow = true;
		scene.add(city);

		
		var geometry = new THREE.TextGeometry( "# GEEKREEBOOT 2020", {
	          size: 200, height: 50, curveSegments: 15,
	          font: "helvetiker", weight: "bold", material: 0, extrudeMaterial: 1,
	          bevelEnabled: true, bevelThickness: 5 , bevelSize: 5
	      });
		var textMat = [
				new THREE.MeshPhongMaterial({color: 0xd5d19a, specular: 0xd73c7c}),
				new THREE.MeshPhongMaterial({color: 0xa87232, specular: 0xd2ba3a})
		];
	    var text = new THREE.Mesh(geometry, new THREE.MeshFaceMaterial(textMat));
		text.castShadow = true;
		text.rotation.y -= (Math.PI/2 + Math.PI/4);
		text.position.set(2500,-80,-500);
	    scene.add(text);
		
		spot1Light.target = text;

		
		listener = new THREE.AudioListener();
		sound1 = new THREE.Audio( listener );
		sound1.load( "sounds/car_startup.mp3" );
		sound2 = new THREE.Audio( listener );
		sound2.load( "sounds/game_theme.wav" );

		keymapping = [];  
		var angle = 0; 

		render = function () {	 
			requestAnimationFrame(render);
			
			stats.update();
			angle += Math.PI / 512;
			
			
			if(carLoaded) {					
				camera4.position.x = car.position.x + (Math.sin(angle) * 100) ;
				camera4.position.z = car.position.z + (Math.cos(angle) * 100) ;
				camera4.lookAt(car.position);		 
				if ( car.position.x > 7500 || car.position.x < -7500 ||	car.position.z > 7500 || car.position.z < -7500 ) {
					 alert("Game Over");
					 car.position.set(0,-89.5,0);
					 velocity = 0.0;
					 POWER = false; FORWARD = false; BACKWARD = false;
				}

			}

			if(POWER) {
				
				if (FORWARD) {		
					car.position.x += dir.x * velocity;
					car.position.z += dir.z * velocity;
					if (keymapping[65]) {  
						rotateY(dir, 4.0);
		                car.rotation.y += toRadians(4.0);
					} else if (keymapping[68]){
						rotateY(dir, -4.0);
		                car.rotation.y += toRadians(-4.0);
					}
				} else if (BACKWARD) {
					car.position.x += dir.x * velocity;
					car.position.z += dir.z * velocity;
					if (keymapping[65]) {
						rotateY(dir, 4.0);
						car.rotation.y += toRadians(4.0);
					} else if (keymapping[68]){
						rotateY(dir, -4.0);
						car.rotation.y += toRadians(-4.0);
					}
				}

				if(BRAKING && FORWARD) {  
					velocity = (velocity >= 0.003) ? velocity - 0.003 : 0.0;
					velocity = Math.round(velocity * 1000) / 1000; 
					if( velocity > 0.0){ 
						POWER = true;  FORWARD = true;  BACKWARD = false; 
					}
					else if( velocity == 0.0){ 
						POWER = false; FORWARD = false; BACKWARD = false; 
					}
					else{ 
						POWER = true;  FORWARD = false; BACKWARD = true;  
					}
				}
			}
			guiParams.speed = velocity * 100;  

			if( whichCamera == 1){
				renderer.render(scene, camera1);
			}
			else if( whichCamera == 2){
				renderer.render(scene, camera2);
			}
			else if( whichCamera == 3){
				renderer.render(scene, camera3);
			}
			else {
				renderer.render(scene, camera4);
				velocity = 0.0;		
				POWER = false;
			}
			detect_collision();
		}
	}
	var raycaster = new THREE.Raycaster();
	function detect_collision(){
		/*
			var pos = man_walk.position.clone();
			camera.updateMatrixWorld();
			pos.project(camera);
			raycaster.setFromCamera({ x: pos.x, y: pos.y }, camera);
			var intersects = [];
			intersects = raycaster.intersectObjects(interactiveObjects, true);
		*/
		var pos = car.position.clone();
		camera1.updateMatrixWorld();
		pos.project(camera1);
		raycaster.setFromCamera({ x: pos.x, y: pos.y }, camera1);
		var intersects = [];
		intersects = raycaster.intersectObjects(collidableMeshList, true);
		if(intersects.length>0){
			console.log(car.position.x);
		}
		// var originPoint = car.position.clone();
		// for(var vertexIndex =0;vertexIndex <car.geometry.vertices.length;vertexIndex++){
		// 		var localVertex = car.geometry.vertices[vertexIndex].clone();
		// 		var globalVertex = localVertex.applyMatrix4( car.matrix );
		// 		var directionVector = globalVertex.sub( car.position );
		// 		var ray = new THREE.Raycaster( originPoint, directionVector.clone().normalize() );
		// 		var collisionResults = ray.intersectObjects( collidableMeshList );
		// 		if (collisionResults.length > 0 && collisionResults[0].distance < directionVector.length() ) {
		// 			// alert('hi');
		// 			//logic
		// 		}
		// }
	}
	function gameOn () {
		document.getElementById("loading").style.display = "none";
		document.getElementsByClassName("container")[0].style.display = "none";
		document.getElementById("canvas").appendChild(renderer.domElement);
		sound2.autoplay = true;
		sound2.play();		
		musicPlaying = true;
		render();	
	}

	function keyup (ev) {
		switch(ev.keyCode) {
			case 87: 
			case 83: 
			case 65: 
			case 68: 
				keymapping[ev.keyCode] = false;
			break;
			default: break;
		}
		if (ev.keyCode == 87)
			BRAKING = true;
	}

	function keydown (ev) {
		switch(ev.keyCode) {
			case 87: 
			case 83: 
			case 65: 
			case 68: 
				keymapping[ev.keyCode] = true;
			break;

			case 81: 
				if (musicPlaying) {
					sound2.pause();
					musicPlaying = false;
				} else {
					sound2.play();
					musicPlaying = true;
				}
			break;

			case 49: 
				whichCamera = 1;
			break;
			case 50: 
				whichCamera = 2;
			break;
			case 51: 
				whichCamera = 3;
			break;
			case 52: 
				whichCamera = 4;
				velocity = 0.0;  
			break;

			default: return; break;
		}

		if (ev.keyCode == 87) {  
			if (velocity == 0.0)	sound1.play();  
				velocity += (velocity > 3.0) ? 0.0 : 0.15;
				BRAKING = false;	
		} else if (ev.keyCode==83) {  
			velocity -= (velocity < -0.5) ? 0.0 : 0.2;
		}

		velocity = Math.round(velocity * 1000) / 1000;
		if( velocity > 0.0){ 
			POWER = true;  
			FORWARD = true;  
			BACKWARD = false; 
		}
		else if( velocity == 0.0){ 
			POWER = false; 
			FORWARD = false; 
			BACKWARD = false; 
		}
		else{ 
			POWER = true;  
			FORWARD = false; 
			BACKWARD = true;  
		}
	}

	function getRandomPosition (max, min) {
		max = max || 1;
		min = min || 0;
		seed = (seed * 9301 + 49297) % 233280;
		var rnd = seed / 233280.0;
		return min + rnd * (max - min);
	}

	function toRadians (degrees) {	return degrees * piRatio; }

	function rotateY (dir, angle) {
		var theta = angle * piRatio;
		var xx =  dir.x * Math.cos(theta) + dir.z * Math.sin(theta);
		var zz = -dir.x * Math.sin(theta) + dir.z * Math.cos(theta);
		dir.x = xx;
		dir.z = zz;
	}

	function onWindowResize() {
		var canvasWidth = window.innerWidth;
		var canvasHeight = window.innerHeight;
		renderer.setSize( canvasWidth, canvasHeight );
		camera1.aspect = canvasWidth/ canvasHeight;
		camera1.updateProjectionMatrix();
		camera2.aspect = canvasWidth/ canvasHeight;
		camera2.updateProjectionMatrix();
		camera3.aspect = canvasWidth/ canvasHeight;
		camera3.updateProjectionMatrix();
		camera4.aspect = canvasWidth/ canvasHeight;
		camera4.updateProjectionMatrix();
	}

	function buildings () {
		var city = new THREE.Object3D();
		var geometry, material, texture, mesh;
		seed = 17;
		build = function getBuilding (geoWidth, geoHeight, geoDepth,
							  		  _color, texPath, posY,
						  	  		  posMaxX, posMinX, posMaxZ, posMinZ) {
			geometry = new THREE.BoxGeometry(geoWidth, geoHeight, geoDepth);
			geometry.faceVertexUvs[0][4][0].set( 0, 0 );
			geometry.faceVertexUvs[0][4][1].set( 0, 0 );
			geometry.faceVertexUvs[0][4][2].set( 0, 0 );
			geometry.faceVertexUvs[0][5][0].set( 0, 0 );
			geometry.faceVertexUvs[0][5][1].set( 0, 0 );
			geometry.faceVertexUvs[0][5][2].set( 0, 0 );

			texture = THREE.ImageUtils.loadTexture(texPath);
			texture.minFilter = texture.magFilter = THREE.LinearFilter;
			texture.anisotropy = maxAnisotropy;

			material = new THREE.MeshLambertMaterial({color: _color, side: THREE.DoubleSide, map: texture});

			mesh = new THREE.Mesh(geometry, material);
			// collidableMeshList.push(mesh);
			mesh.castShadow = true;

			mesh.position.set(getRandomPosition(posMaxX,posMinX),posY,getRandomPosition(posMaxZ,posMinZ));
			city.add(mesh);
		};

		for (var i = 0; i < 3; i++) { 
			build(500,1400,500,  0x474550,"textures/Building_texture3.jpg",300,  -1900,-500,  -2000,5000);
			build(200,1000,200,  0xad9aa0,"textures/Building_texture5.jpg",300,  -1900,-500,  -2000,5000);
			build(500,800,300,   0xffffff,"textures/buildings_buildings_0108_02_preview.jpg",300,  -1900,-500,  -2000,5000);
		}

		seed = 5;

		for (var i = 0; i < 3; i++) {
			build(200,500,200,  0xad9aa0,"textures/building-texture1.jpg",100,  -1000,2000,  2500,4800);
			build(300,800,600,  0xffffff,"textures/Building_texture4.jpg",300,  -1000,2000,  2500,4800);
		}
		return city;
	}


	function loadPlants () {
		var loadPlants = new THREE.Object3D();
		var treeMaterials = [], bushMaterials = [], tex;

		tex = THREE.ImageUtils.loadTexture("textures/tree.png");
		tex.minFilter = tex.magFilter = THREE.LinearFilter;
		treeMaterials.push(new THREE.SpriteMaterial({map: tex}) );

		tex = THREE.ImageUtils.loadTexture("textures/tree_PNG224.png");
		tex.minFilter = tex.magFilter = THREE.LinearFilter;
		treeMaterials.push(new THREE.SpriteMaterial({map: tex}) );

		tex = THREE.ImageUtils.loadTexture("textures/hackberry_tree_20131230_1040936985.png");
		tex.minFilter = tex.magFilter = THREE.LinearFilter;
		treeMaterials.push(new THREE.SpriteMaterial({map: tex}) );

		tex = THREE.ImageUtils.loadTexture("textures/bush_04_.png");
		tex.minFilter = tex.magFilter = THREE.LinearFilter;
		bushMaterials.push(new THREE.SpriteMaterial({map: tex}) );

		tex = THREE.ImageUtils.loadTexture("textures/bush_PNG7202.png");
		tex.minFilter = tex.magFilter = THREE.LinearFilter;
		bushMaterials.push(new THREE.SpriteMaterial({map: tex}) );

		plant = function getPlant(isTree, posMaxX, posMinX, posMaxZ, posMinZ) {
			if (isTree) {
			var p = new THREE.Sprite( treeMaterials[Math.round(Math.random() * 2)] ); 
			p.position.set( getRandomPosition(posMaxX, posMinX), -40, getRandomPosition(posMaxZ, posMinZ) );
			p.scale.set( 700, 700, 1.0 ); 
			} else {
			var p = new THREE.Sprite( bushMaterials[Math.round(Math.random())] );
			p.position.set( getRandomPosition(posMaxX, posMinX), -65, getRandomPosition(posMaxZ, posMinZ) );
			p.scale.set( 500, 500, 1.0 );
			}
			loadPlants.add( p );
		};

		for (var i = 0; i < 100; i++) { 
			plant(true, 7500,4500, 7000,-7000);
			plant(false, 7500,4500, 7000,-7000);
		}

		for (var i = 0; i < 100; i++) {
			plant(true, -3500,-7000, 7000,-7000);
			plant(false, -3500,-7000, 7000,-7000);
		}

		for (var i = 0; i < 50; i++) { 
			plant(true, -7000,7000, -5500,-7000);
			plant(false, -7000,7000, -5500,-7000);
		}

		for (var i = 0; i < 25; i++) { 
			plant(true, -5000,5000, 6500,7000);
			plant(true, -5000,5000, 6500,7000);
		}
		return loadPlants;
	}


	function track () {
		var totalGeometry = new THREE.Geometry();
		var mesh, meshes = [];

		var tAsphalt = THREE.ImageUtils.loadTexture("textures/PRS-2-New-with-light-wear-close.jpg");
		tAsphalt.minFilter = THREE.LinearFilter;
		tAsphalt.magFilter = THREE.LinearFilter;
		tAsphalt.anisotropy = maxAnisotropy;
		tAsphalt.wrapS = tAsphalt.wrapT = THREE.ClampToEdgeWrapping;

		var material = new THREE.MeshPhongMaterial({color: 0x665a5a, map: tAsphalt, shading: THREE.SmoothShading,
			 side: THREE.DoubleSide, depthWrite: false, polygonOffset: true, polygonOffsetFactor: -10, polygonOffsetUnits: 4.0});

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 1025 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(-500,5,261);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.RingGeometry( 75, 25, 30, 30, 1.5, 1.57 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.rotation.z += Math.PI / 2;
		mesh.position.set(-450,5,-250);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 150 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.rotation.z += Math.PI / 2;
		mesh.position.set(-380,5,-300);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.RingGeometry( 75, 25, 30, 30, 0, 1.57 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(-310,5,-350);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 200 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(-260,5,-450);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.RingGeometry( 75, 25, 30, 30, 1.5, 3.15 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.rotation.z += Math.PI / 2;
		mesh.position.set(-210,5,-550);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 700 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(-160,5,-205);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.RingGeometry( 150, 100, 30, 30, 1.9, 1.25 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(-35,5,145);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 200 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.rotation.z -= Math.PI / 3 + 0.285;
		mesh.position.set(20,5,287);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.RingGeometry( 250, 200, 30, 30, 5, 2.75 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.position.set(50,5,525);
		meshes.push(mesh);

		mesh = new THREE.Mesh( new THREE.PlaneGeometry( 50, 560 ), material);
		mesh.rotation.x += Math.PI / 2;
		mesh.rotation.z += Math.PI / 2;
		mesh.position.set(-205,5,748.5);
		meshes.push(mesh);

		for ( var i in meshes ) {
			meshes[i].updateMatrix();
			totalGeometry.merge(meshes[i].geometry, meshes[i].matrix);
		}
		totalGeometry.mergeVertices();

		mesh = new THREE.Mesh(totalGeometry, material);
		mesh.receiveShadow = true;
		console.log(collidableMeshList);
		return mesh; 
	}
</script>
    <div id='back'>
        <input type="button" name="back" value="Back To Home" onclick="navigateToHome()">
    </div>
</body>

</html>
